using Atomx.Admin.Client.Models;
using FluentValidation;

namespace Atomx.Admin.Client.Validators
{
    public class ManufacturerModelValidator : AbstractValidator<ManufacturerModel>
    {
        public ManufacturerModelValidator()
        {
            RuleFor(p => p.Name).NotEmpty().WithMessage("名称不能为空");
        }

        public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
        {
            var result = await ValidateAsync(ValidationContext<ManufacturerModel>.CreateWithOptions((ManufacturerModel)model, x => { x.IncludeProperties(propertyName); }));
            if (result.IsValid)
                return Array.Empty<string>();
            return result.Errors.Select(e => e.ErrorMessage);
        };
    }
}
